import { put, takeEvery, delay } from 'redux-saga/effects';
import { intervalChannel } from './interval';
import SagaTester from 'redux-saga-tester';

function* putAction() {
    yield put({ type: 'TEST' });
}

function* test() {
    yield takeEvery(intervalChannel(10), putAction);
}

describe('interval', () => {
    it('should run interval', async () => {
        const sagaTester = new SagaTester();
        sagaTester.start(test);
        await sagaTester.waitFor('TEST');
        expect(sagaTester.numCalled('TEST')).toBe(1);
    });
});
